﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using System.Net.Http;
using Windows.Data.Json;
using Windows.UI.Xaml.Shapes;
using Windows.UI;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace Windows8Client
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }
        
        private void AddCircle(Color color, int diameter, int t, int l)
        {
            //
            // Build a circle using the attributes provided as parameters.
            // 
            Ellipse newColoredCircle = new Ellipse();
            newColoredCircle.Fill = new SolidColorBrush(color);
            newColoredCircle.StrokeThickness = 1;
            newColoredCircle.Stroke = new SolidColorBrush(color);
            newColoredCircle.Width = diameter;
            newColoredCircle.Height = diameter;
            //
            // Add the circle to the Canvas control.
            // 
            myCanvas.Children.Add(newColoredCircle);
            Canvas.SetTop(newColoredCircle, t);
            Canvas.SetLeft(newColoredCircle, l);
        }

        Color CircleColorFromString(string rgb)
        {
            //
            // Convert the string-based hex values 
            // into a Color object and return to caller.
            // 
            Color ringColor = new Color();
            byte a = 255;
            byte r = (byte)(Convert.ToUInt32(rgb.Substring(1, 2), 16));
            byte g = (byte)(Convert.ToUInt32(rgb.Substring(3, 2), 16));
            byte b = (byte)(Convert.ToUInt32(rgb.Substring(5, 2), 16));
            ringColor = Color.FromArgb(a, r, g, b);
            return ringColor;
        }

        private async void GridLoadedEvent(object sender, RoutedEventArgs e)
        {
            //
            // Retrieve colors from web service
            //
            var client = new HttpClient();
            client.MaxResponseContentBufferSize = 1024 * 1024;

            //
            // Asynchronously call into the web service
            // 
            var response = await client.GetAsync(new Uri("http://localhost:1165/api/values"));

            var result = await response.Content.ReadAsStringAsync();

            //
            // Parse the JSON data
            //
            var parsedResults = JsonArray.Parse(result);

            //
            // Build concentric circles, repeating colors as needed
            //

            const double startingPercentage = 1.0;
            const double desiredCircleCount = 50.0;
            for (int i = 0; i < desiredCircleCount; i++)
            {
                Color circleColor = CircleColorFromString(parsedResults[i % parsedResults.Count].GetString());
                int circleDiameter = Convert.ToInt32((startingPercentage - (i / desiredCircleCount)) * this.RenderSize.Width / 2.0);
                int top = Convert.ToInt32((this.RenderSize.Height - circleDiameter) / 2.0);
                int left = Convert.ToInt32((this.RenderSize.Width - circleDiameter) / 2.0);
                AddCircle(circleColor, circleDiameter, top, left);
            }
        }

    }
}
